# Generated by Django 3.2.19 on 2024-02-02 11:40

import core.fields
import dirtyfields.dirtyfields
from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import simple_history.models


class Migration(migrations.Migration):

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('payroll', '0010_auto_20240131_1015'),
    ]

    operations = [
        migrations.RemoveField(
            model_name='historicalpayroll',
            name='benefit_plan',
        ),
        migrations.RemoveField(
            model_name='payroll',
            name='benefit_plan',
        ),
        migrations.AddField(
            model_name='historicalpayroll',
            name='payment_cycle',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='payment_cycle.paymentcycle'),
        ),
        migrations.AddField(
            model_name='historicalpayroll',
            name='payment_plan',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='contribution_plan.paymentplan'),
        ),
        migrations.AddField(
            model_name='payroll',
            name='payment_cycle',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.DO_NOTHING, to='payment_cycle.paymentcycle'),
        ),
        migrations.AddField(
            model_name='payroll',
            name='payment_plan',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.DO_NOTHING, to='contribution_plan.paymentplan'),
        ),
        migrations.AlterField(
            model_name='benefitconsumption',
            name='status',
            field=models.CharField(choices=[('CREATED', 'CREATED'), ('ACCEPTED', 'ACCEPTED'), ('REJECTED', 'REJECTED'), ('DUPLICATE', 'DUPLICATE'), ('AWAITING_FOR_RECONCILIATION', 'AWAITING_FOR_RECONCILIATION'), ('RECONCILIATED', 'RECONCILIATED')], default='ACCEPTED', max_length=100),
        ),
        migrations.AlterField(
            model_name='historicalbenefitconsumption',
            name='status',
            field=models.CharField(choices=[('CREATED', 'CREATED'), ('ACCEPTED', 'ACCEPTED'), ('REJECTED', 'REJECTED'), ('DUPLICATE', 'DUPLICATE'), ('AWAITING_FOR_RECONCILIATION', 'AWAITING_FOR_RECONCILIATION'), ('RECONCILIATED', 'RECONCILIATED')], default='ACCEPTED', max_length=100),
        ),
        migrations.CreateModel(
            name='PayrollBenefitConsumption',
            fields=[
                ('id', models.UUIDField(db_column='UUID', default=None, editable=False, primary_key=True, serialize=False)),
                ('is_deleted', models.BooleanField(db_column='isDeleted', default=False)),
                ('json_ext', models.JSONField(blank=True, db_column='Json_ext', null=True)),
                ('date_created', core.fields.DateTimeField(db_column='DateCreated', null=True)),
                ('date_updated', core.fields.DateTimeField(db_column='DateUpdated', null=True)),
                ('version', models.IntegerField(default=1)),
                ('benefit', models.ForeignKey(on_delete=django.db.models.deletion.DO_NOTHING, to='payroll.benefitconsumption')),
                ('payroll', models.ForeignKey(on_delete=django.db.models.deletion.DO_NOTHING, to='payroll.payroll')),
                ('user_created', models.ForeignKey(db_column='UserCreatedUUID', on_delete=django.db.models.deletion.DO_NOTHING, related_name='payrollbenefitconsumption_user_created', to=settings.AUTH_USER_MODEL)),
                ('user_updated', models.ForeignKey(db_column='UserUpdatedUUID', on_delete=django.db.models.deletion.DO_NOTHING, related_name='payrollbenefitconsumption_user_updated', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'abstract': False,
            },
            bases=(dirtyfields.dirtyfields.DirtyFieldsMixin, models.Model),
        ),
        migrations.CreateModel(
            name='HistoricalPayrollBenefitConsumption',
            fields=[
                ('id', models.UUIDField(db_column='UUID', db_index=True, default=None, editable=False)),
                ('is_deleted', models.BooleanField(db_column='isDeleted', default=False)),
                ('json_ext', models.JSONField(blank=True, db_column='Json_ext', null=True)),
                ('date_created', core.fields.DateTimeField(db_column='DateCreated', null=True)),
                ('date_updated', core.fields.DateTimeField(db_column='DateUpdated', null=True)),
                ('version', models.IntegerField(default=1)),
                ('history_id', models.AutoField(primary_key=True, serialize=False)),
                ('history_date', models.DateTimeField(db_index=True)),
                ('history_change_reason', models.CharField(max_length=100, null=True)),
                ('history_type', models.CharField(choices=[('+', 'Created'), ('~', 'Changed'), ('-', 'Deleted')], max_length=1)),
                ('benefit', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='payroll.benefitconsumption')),
                ('history_user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('payroll', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='payroll.payroll')),
                ('user_created', models.ForeignKey(blank=True, db_column='UserCreatedUUID', db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('user_updated', models.ForeignKey(blank=True, db_column='UserUpdatedUUID', db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'historical payroll benefit consumption',
                'verbose_name_plural': 'historical payroll benefit consumptions',
                'ordering': ('-history_date', '-history_id'),
                'get_latest_by': ('history_date', 'history_id'),
            },
            bases=(simple_history.models.HistoricalChanges, models.Model),
        ),
    ]
